/*
 *	AreaFix/FileFix main module
 *	(LazyFix Project)
 *
 *	Public domain: may be copied and sold freely
 */

#include	<stdio.h>
#include	<stdlib.h>
#include	<time.h>
#include	<portab.h>
#include	<ctype.h>
#include	<string.h>

#include	"lfix.h"
#include    "qbbs.h"
#include	"areafix.h"
#include	"misc.h"
#include	"config.h"

#ifdef LATTICE /* for atari Lattice C 5 */
unsigned long _STACK=16000;
#endif

int main(int argc, char **argv)
{
	char fnam[BBSSTR],fnam2[BBSSTR];
	char tempfix[BBSSTR];
	FILE *myfp;
	FILE *msgtext,*msgtemp;
	QBBS_MHEADER curhead;
	FIDONODE moi;
	int filefix,loopc=0,got;
	long msize;
	unsigned char bufc;
	int debug=0;
	
	if(argc>1)
		debug++;
		
	/* banner */
	printf("%s version %s (compiled on %s)\n",LAZYNAME,LAZYVERS,__DATE__);
	printf("A Public Domain Program. May be copied and sold freely.\n\n");

	/* init cfg */
	open_config();
	if(debug)
		debug_config();
	
	/* makes name */
	strcpy(fnam,get_netmail());
	strcat(fnam,".HDR");
	strcpy(fnam2,get_netmail());
	strcat(fnam2,".MSG");
	

	do {
		got=0;
		filefix=0;
		loopc++;
		/* open netmail header */
		logline(1,"Scanning netmail");
		myfp=fopen(fnam,"rb+");
		if(!myfp)
		{
			logline(4,"Can't open netmail header %s",fnam);
			return 100;
		}
	
		/* scan netmail HDR */
		while(myfp && fread(&curhead,sizeof(QBBS_MHEADER),1,myfp)==1)
		{
			if(	(curhead.attrib & PRVTFLAG) /* message is private */
				&& (!(curhead.attrib & KILLFLAG)) /* message !expired */
				&& (!(curhead.attrib & RCVDFLAG)) ) /* we already replied */
			{
				if(	!stricmp(curhead.to,AREAFIXN1) /* is to areafix/filefix */
					|| !stricmp(curhead.to,AREAFIXN2)
					|| !stricmp(curhead.to,AREAFIXN3)
					|| !stricmp(curhead.to,FILEFIXN1)
					|| !stricmp(curhead.to,FILEFIXN2)
					|| !stricmp(curhead.to,FILEFIXN3))
				{
					if(	stricmp(curhead.from,AREAFIXN1) /* is not loop? */
						&& stricmp(curhead.from,FILEFIXN1))
					{
						/* check msg is to us (our correct aka indeed) */
						get_ouraddress(&moi,curhead.o_zone,curhead.o_net,
							curhead.o_node,curhead.o_point);
						if( curhead.d_zone==moi.zone
							&& curhead.d_net==moi.net
							&& curhead.d_node==moi.node
							&& curhead.d_point==moi.point )
						{
							if(	!stricmp(curhead.to,FILEFIXN1) /* filefix */
								|| !stricmp(curhead.to,FILEFIXN2)
								|| !stricmp(curhead.to,FILEFIXN3))
								filefix++;
				
							logline(1,"Found message from %s (%d:%d/%d.%d) to %s",
								curhead.from,(int)curhead.o_zone,(int)curhead.o_net,
								(int)curhead.o_node,(int)curhead.o_point,
								(filefix?"Filefix":"Areafix"));
				
							/* make temp msg contents */
							msgtext=fopen(fnam2,"rb");
							if(!msgtext)
								logline(3,"Can't open %s",fnam2);
							else
							{
								/* tempfile for original message */
								strcpy(tempfix,get_ticktemp());
								strcat(tempfix,LFIXTEMP1);
								msgtemp=fopen(tempfix,"wb");
								if(msgtemp)
								{
									if(fseek(msgtext,(long) curhead.msgoffset,SEEK_SET)>=0)
									{
										msize=(long) curhead.size;
										/* now copy */
										while(msize>0 && fread(&bufc,1,1,msgtext)==1)
										{
											fwrite(&bufc,1,1,msgtemp);
											msize--;
										}
									}
									/* close temp */
									fclose(msgtemp);
								}
								else
									logline(3,"Can't open %s",tempfix);
								fclose(msgtext);
							
								/* kill/rcvd original msg */
								curhead.attrib|=RCVDFLAG;
								curhead.attrib|=KILLFLAG;
							
								/* update header */
								if(fseek(myfp,(-((long)sizeof(QBBS_MHEADER))),SEEK_CUR)<0) /* back to current head */
									logline(4,"fseek() error on %s",fnam);
								else
								{							
									if(fwrite(&curhead,sizeof(QBBS_MHEADER),1,myfp)!=1)
										logline(4,"Write error during flags update");
									else
										got++;
								}
						
								/* close for reply */
								fclose(myfp); myfp=NULL;

								/* process request */
								do_areafix(curhead.from,curhead.subject,
									curhead.o_zone,curhead.o_net,curhead.o_node,curhead.o_point,
									filefix);
						
								/* delete msg temp */
								if(remove(tempfix))
									logline(3,"Can't remove %s",tempfix);
							
								/* stop, reopen */
								filefix=0;
								break;
							}
						}
						else
							logline(1,"Message from %s (%d:%d/%d.%d) to %s (%d:%d/%d.%d)?",
								curhead.from,
								(int)curhead.o_zone,(int)curhead.o_net,
								(int)curhead.o_node,(int)curhead.o_point,
								curhead.to,
								(int)curhead.d_zone,(int)curhead.d_net,
								(int)curhead.d_node,(int)curhead.d_point);
					}
				}
			}
		}
		if(myfp)
			fclose(myfp); /* close netmail HDR */
	} while(got && loopc<10); /* rescan loop */
	
	/* close cfg */
	close_config();	
	
	return 0;
}

/**/