/* 
 *	LazyFix main header
 *	(LazyFix project) 
 *
 *	Public Domain - May be copied and sold freely
 */

#define LAZYVERS	"0.2"
#define LAZYNAME	"LazyFix"
#define LAZYLGID	"LFIX"

/* system dependancies UNIX */
#ifdef UNIX
#define SYSSTRSEPAR "/"
#define SYSSEPAR '/' 
#define MACHINE "Unix"
#define stricmp strcasecmp
#define strnicmp strncasecmp
#endif

/* system dependancies ATARI ST */
#ifdef ATARI
#define SYSSTRSEPAR	"\\"
#define SYSSEPAR '\\'
#define MACHINE "Atari ST"
#endif

/* system dependancies Windows NT */
#ifdef WIN32
#define SYSSTRSEPAR	"\\"
#define SYSSEPAR '\\'
#define MACHINE "WinNT"
#endif

/* config files */
#define GET_PASSTHRU				/* get passthru areas (misc.c) */
#define FAREASFILE	"fareas.bbs"	/* files areas list */
#define AREASFILE	"areas.bbs"		/* echomail areas list */
#define DEFLOGFILE	"lazyfix.log"	/* default log file */
#define FILESBBS	"files.bbs"		/* file desc in fileareas */
#define BERMCFG1	"bermuda.cfg"	/* config file */
#define BERMCFG2	"tb.cfg"

/* internal limits */
#define BBSOK 		0
#define BBSFAIL 	1
#define BBSSTR	 	150	/* generic string */
#define MAXECHO		400	/* max number of areas */

/* tempfiles */
#define LFIXTEMP1	"_lfix_1_.tmp"
#define LFIXTEMP2	"_lfix_2_.tmp"

/* robot names */
#define AREAFIXN1	"Areafix"
#define AREAFIXN2	"Areamgr"
#define AREAFIXN3	"Lazyfix"
#define FILEFIXN1	"Filefix"
#define FILEFIXN2	"Raid"
#define FILEFIXN3	"Filemgr"

/* structures */

typedef struct _fidonode {
	struct _fidonode *next;
	int position; /* for areafix */
	int zone;
	int net;
	int node;
	int point;
} FIDONODE;

typedef struct _echolist {
	char file[BBSSTR];  /* Name of HDR/MSG */
	char name[BBSSTR];	/* Fido Name */
	char desc[BBSSTR];	/* Description */
	char group[BBSSTR];	/* Group */
	int line;			/* areas.bbs line number for areafix */
	int modify;			/* for areafix */
	FIDONODE *firstnode;
} ECHOLIST;

/* end of lfix.h */
